import os
import datetime
import offer

def user(): return dict(form=auth())
def download(): return response.download(request,db)
def call():
    session.forget()
    return service()
### end requires

@auth.requires_membership('Administrator')
def index():
    date_form = FORM("Date:", INPUT(_class="date", _name="req_date"),
                       INPUT(_type="submit", _label="Generate"),
                       _action = URL('index'))

    if (date_form.accepts(request.vars, session)):
        session.flash = "Editing transactions"
        req_date = date_form.vars.req_date
        redirect(URL(r=request, f="edit_transactions", vars=dict(d = req_date)))
    return dict(dateform=date_form)

def edit_transactions():
    req_date = request.vars.d
    try:
        qry_date = datetime.date(year = datetime.datetime.strptime(req_date, "%Y-%d-%m").year,
                                 day = datetime.datetime.strptime(req_date, "%Y-%d-%m").day,
                                 month = datetime.datetime.strptime(req_date, "%Y-%d-%m").month)
    except:
        response.flash = 'Invalid date supplied'
        redirect(URL(r = request, f='index'))

    # Build list of editing links
    links = []

    for row in db(db.seetsoc_ohs_transactions.delivery_date == qry_date).select(db.seetsoc_ohs_transactions.ALL,
                           orderby=db.seetsoc_ohs_transactions.interval):

        party_query = db.seetsoc_ohs_parties.id == row.party_id
        party_set = db(party_query)
        party_rows = party_set.select()

        links.append(dict(bid_id = row.id,
                          bid_type = row.bid_type,
                          party_name = party_rows.first().Name,
                          eng_type = row.eng_type,
                          qty = row.qty,
                          interval = row.interval,
                          transaction = row.transactioned,
                          link=URL('edit_transaction',vars=dict(trans_id=row.id, d = req_date))))

    return dict(date = request.vars.d, links = links)

@auth.requires_membership('Administrator')
def edit_transaction():
    trans_id = request.vars.trans_id
    req_date = request.vars.d
    record = db.seetsoc_ohs_transactions(request.vars.trans_id) or redirect(URL('edit_transaction', vars=dict(trans_id=trans_id)))
    form = SQLFORM(db.seetsoc_ohs_transactions, record)
    if form.process().accepted:
        response.flash = "Successfully committed"
        redirect(URL(r = request, f = 'edit_transactions', vars = dict(d = req_date)))
    elif form.errors:
        response.flash = form.errors.name
        print form.errors
    return dict(bid_id=request.vars.bid_id, form=form)
