import offer
import merit
import datetime

def user(): return dict(form=auth())
def download(): return response.download(request,db)
def call():
    session.forget()
    return service()
### end requires
#@auth.requires_login()
@auth.requires_membership('Administrator')
def index():
    choice_form = FORM("Type:", SELECT("Upward Tertiary",
                                       "Downward Tertiary",
                                       _name="eng_type", value="yes"),
                       "Date:", INPUT(_class="date", _name="req_date", _size=10),
                       "Maximum quantity (MW):",
                       INPUT(_name="maxqty", type="integer", _label="Maximum quantity (MW)", _size=4),
                       INPUT(_type="submit", _label="Generate"),
                       _action = URL('index'))

    if choice_form.accepts(request.vars, session):
        session.flash = "Viewing Merit Order"
        req_date = choice_form.vars.req_date
        if choice_form.vars.eng_type == "Upward Tertiary":
            redirect(URL(r=request, f='mo_up_tertiary', vars=dict(d = req_date, q = choice_form.vars.maxqty)))
        elif choice_form.vars.eng_type == "Downward Tertiary":
            redirect(URL(r=request, f='mo_down_tertiary', vars=dict(d = req_date, q = choice_form.vars.maxqty)))
        else:
            redirect(URL('index'))

    return dict(form = choice_form)

@auth.requires_membership('Administrator')
def commit_mo():
    eng_type = None

    mo_type = request.vars.t
    if mo_type == "up_tertiary":
        eng_type = offer.OFF_TYPE_TERTIARY_UP
    else:
        eng_type = offer.OFF_TYPE_TERTIARY_DOWN

    mo_date = request.vars.d

    qry_date = datetime.date(year = datetime.datetime.strptime(mo_date, "%Y-%d-%m").year,
                             day = datetime.datetime.strptime(mo_date, "%Y-%d-%m").day,
                             month = datetime.datetime.strptime(mo_date, "%Y-%d-%m").month)

    transactions = []

    interval = 1
    for mo in session.mos:
        print mo
        # Buying bids:
        if mo["mcp"] != None:
            for bid in mo["buy_bids"]:
                transactions.append(dict(party_id = bid["tso_id"],
                                         bid_id = bid["bid_id"],
                                         bid_type = offer.OFF_TYPE_BUY,
                                         eng_type = eng_type,
                                         offer_id = bid["offer_id"],
                                         delivery_date = qry_date,
                                         interval = interval,
                                         qty = bid["qty"],
                                         mcp = mo["mcp"],
                                         orig_price = bid["price"],
                                         transactioned = False,
                                         final_price = bid["price"],
                                         final_qty = bid["qty"]))
        # Selling bids:
        if mo["mcp"] != None:
            for bid in mo["sell_bids"]:
                transactions.append(dict(party_id = bid["tso_id"],
                                         bid_id = bid["bid_id"],
                                         bid_type = offer.OFF_TYPE_SALE,
                                         eng_type = eng_type,
                                         offer_id = bid["offer_id"],
                                         delivery_date = qry_date,
                                         interval = interval,
                                         qty = bid["qty"],
                                         mcp = mo["mcp"],
                                         orig_price = bid["price"],
                                         transactioned = False,
                                         final_price = bid["price"],
                                         final_qty = bid["qty"]))
        interval = interval + 1
    db.seetsoc_ohs_transactions.bulk_insert(transactions)
    return dict(mo_type = mo_type, mo_date = mo_date)

@auth.requires_membership('Administrator')
def mo_up_tertiary():
    commit_form = FORM("Submit order for verification and committing:",
                       INPUT(_type='submit', _text='Commit'), action=mo_up_tertiary)
    req_date = request.vars.d
    req_qty = None

    if request.vars.q != "":
        req_qty = rtoi(str(request.vars.q))
    if commit_form.accepts(request.vars, session):
        redirect(URL(r = request, f='commit_mo',
                     vars = dict(d = req_date, t = "up_tertiary")))
    else:
        # Get the date for which we're querying
        try:
            qry_date = datetime.date(year = datetime.datetime.strptime(req_date, "%Y-%d-%m").year,
                                     day = datetime.datetime.strptime(req_date, "%Y-%d-%m").day,
                                     month = datetime.datetime.strptime(req_date, "%Y-%d-%m").month)
        except:
            response.flash = 'Invalid date supplied'
            redirect(URL(r = request, f='index'))
        merit_orders = []

        for interval in range(1, 24, +1):
            # Get buy and sell bids for interval
            b = selling_bids(qry_date, interval, offer.OFF_TYPE_TERTIARY_UP)
            s = buying_bids(qry_date, interval, offer.OFF_TYPE_TERTIARY_UP)

            mo = merit.mo_upward_tertiary(b, s, limit = req_qty)

            if mo == None:
                merit_orders.append(dict(interval = interval,
                                         mcp = None))
            else:
                stats = merit.get_stats(mo)
                merit_orders.append(dict(interval = interval,
                                         buy_bids = mo[0],
                                         sell_bids = mo[1],
                                         mcp = mo[2],
                                         stats = stats,
                                         all_buys = mo[3],
                                         all_sales = mo[4]))
        session.mos = merit_orders
        return dict(commit_form = commit_form,
                    mos = merit_orders)

@auth.requires_membership('Administrator')
def mo_down_tertiary():
    commit_form = FORM("Submit order for verification and committing:",
                       INPUT(_type='submit', _text='Commit'), action=mo_down_tertiary)
    req_date = request.vars.d
    req_qty = None

    if request.vars.q != "":
        req_qty = rtoi(str(request.vars.q))
    if commit_form.accepts(request.vars, session):
        redirect(URL(r = request, f='commit_mo',
                     vars = dict(d = req_date, t = "down_tertiary")))
    else:
        try:
            qry_date = datetime.date(year = datetime.datetime.strptime(req_date, "%Y-%d-%m").year,
                                     day = datetime.datetime.strptime(req_date, "%Y-%d-%m").day,
                                     month = datetime.datetime.strptime(req_date, "%Y-%d-%m").month)
        except:
            response.flash = 'Invalid date supplied'
            redirect(URL(r = request, f='index'))

        merit_orders = []

        for interval in range(1, 24, +1):
            # Get buy and sell bids for interval
            b = selling_bids(qry_date, interval, offer.OFF_TYPE_TERTIARY_DOWN)
            s = buying_bids(qry_date, interval, offer.OFF_TYPE_TERTIARY_DOWN)

            mo = merit.mo_downward_tertiary(b, s, limit = req_qty)

            if mo == None:
                merit_orders.append(dict(interval = interval,
                                         mcp = None))
            else:
                stats = merit.get_stats(mo)
                merit_orders.append(dict(interval = interval,
                                         buy_bids = mo[0],
                                         sell_bids = mo[1],
                                         mcp = mo[2],
                                         stats = stats,
                                         all_buys = mo[3],
                                         all_sales = mo[4]))
        session.mos = merit_orders
        return dict(commit_form = commit_form,
                    mos = merit_orders)

@auth.requires_membership('Administrator')
def buying_bids(req_date, req_interval, req_eng_type):
    offer_id = db.seetsoc_ohs_offer.id
    bid_id = db.seetsoc_ohs_bids.id
    qty = db.seetsoc_ohs_bids.qty
    price = db.seetsoc_ohs_bids.price
    off_type = db.seetsoc_ohs_offer.off_type
    date = db.seetsoc_ohs_offer.delivery_date
    interval = db.seetsoc_ohs_bids.interval
    eng_type = db.seetsoc_ohs_bids.eng_type
    bid_type = db.seetsoc_ohs_bids.bid_type
    tso_id = db.seetsoc_ohs_offer.eic
    tso_name = db.seetsoc_ohs_parties.Name

    bid_list = []

    for row in db((date == req_date) & (interval == req_interval) & (eng_type == req_eng_type) & (bid_type == offer.OFF_TYPE_BUY) & (db.seetsoc_ohs_bids.offer_id == db.seetsoc_ohs_offer.id)).\
            select(interval, eng_type, bid_id, qty, tso_id, offer_id, price):
        bid_list.append([row.seetsoc_ohs_offer.id,
                         row.seetsoc_ohs_bids.id,
                         int(row.seetsoc_ohs_bids.price),
                         int(row.seetsoc_ohs_bids.qty),
                         True,
                         0,
                         int(row.seetsoc_ohs_offer.eic),
                         "TSO"])

    return bid_list

@auth.requires_membership('Administrator')
def selling_bids(req_date, req_interval, req_eng_type):
    offer_id = db.seetsoc_ohs_offer.id
    off_type = db.seetsoc_ohs_offer.off_type
    bid_id = db.seetsoc_ohs_bids.id
    qty = db.seetsoc_ohs_bids.qty
    price = db.seetsoc_ohs_bids.price
    date = db.seetsoc_ohs_offer.delivery_date
    interval = db.seetsoc_ohs_bids.interval
    eng_type = db.seetsoc_ohs_bids.eng_type
    bid_type = db.seetsoc_ohs_bids.bid_type
    tso_id = db.seetsoc_ohs_offer.eic

    bid_list = []

    for row in db((date == req_date) & (interval == req_interval) & (eng_type == req_eng_type) & (bid_type == offer.OFF_TYPE_SALE) & (db.seetsoc_ohs_bids.offer_id == db.seetsoc_ohs_offer.id)).\
            select(interval, eng_type, bid_id, qty, tso_id, offer_id, price):
        bid_list.append([row.seetsoc_ohs_offer.id,
                         row.seetsoc_ohs_bids.id,
                         int(row.seetsoc_ohs_bids.price),
                         int(row.seetsoc_ohs_bids.qty),
                         True,
                         0,
                         int(row.seetsoc_ohs_offer.eic),
                         "TSO"])
    return bid_list
