import os
import datetime
import offer

def user(): return dict(form=auth())
def download(): return response.download(request,db)
def call():
    session.forget()
    return service()
### end requires

@auth.requires_membership('Administrator')
def index():
    date_form = FORM("Date:", INPUT(_class="date", _name="req_date"),
                         INPUT(_type="submit", _label="Generate"),
                         _action = URL('index'))
    if (date_form.accepts(request.vars, session)):
        req_date = date_form.vars.req_date
        redirect(URL(r=request, f="generate_for_day", vars=dict(d = req_date)))
    return dict(date_form = date_form)

@auth.requires_membership('Administrator')
def generate_for_day():
    req_date = request.vars.d
    try:
        qry_date = datetime.date(year = datetime.datetime.strptime(req_date, "%Y-%d-%m").year,
                                 day = datetime.datetime.strptime(req_date, "%Y-%d-%m").day,
                                 month = datetime.datetime.strptime(req_date, "%Y-%d-%m").month)
    except:
        response.flash = 'Invalid date supplied'
        redirect(URL(r = request, f='index'))
        # Get all the transactions settled and completed for that day

    query = (db.seetsoc_ohs_transactions.transactioned == True) & \
        (db.seetsoc_ohs_transactions.delivery_date == qry_date)

    rows = db(query).select()

    buys = filter(lambda row: (row.bid_type == 1), rows)
    sales = filter(lambda row: (row.bid_type == 0), rows)

    sett_notes = []

    for i in range(24):
        ibuys = filter(lambda buy : (buy.interval == i), buys)
        isales = filter(lambda sale: (sale.interval == i), sales)

    # Compute imbalance price for every purchase quantity
        Qimb = 0
        for buy in ibuys:
            Qimb = Qimb + buy.final_qty

        for buy in ibuys:
            Vbe = 0
            for sale in isales:
                Vbe = Vbe + ((sale.final_qty * sale.final_price) / 100)

            Vimb = Vbe
            pimb = Vimb / Qimb
            Vimb_f = buy.final_qty * pimb / 100

            sett_notes.append(dict(date = qry_date,
                                   interval = i,
                                   metered_qty = buy.final_qty,
                                   vimb = Vimb_f,
                                   TSO = buy.party_id))

    db.setsoc_ohs_settlement_notes.bulk_insert(sett_notes)
    rows = db(query).delete()
    return dict(req_date = req_date,
                no_sett_notes = len(sett_notes))
