import os
import datetime
import offer

USER_TABLE_QUERY = 'SELECT * from auth_user, auth_group, auth_membership WHERE auth_membership.user_id == auth_user.id AND auth_membership.group_id == auth_group.id;'
TSO_TABLE_QUERY = 'SELECT * from seetsoc_ohs_parties'

USER_ID = 1
ADMIN_ID = 2

# (1, u'John', u'Doe', u'johndoe@gmail.com', 1, u'dac13ededea0c52ab9eed85689861f48', u'', u'', u'', 4, u'User', u'', 3, 1, 4)


def user(): return dict(form=auth())
def download(): return response.download(request,db)
def call():
    session.forget()
    return service()
### end requires

@auth.requires_membership('Administrator')
def index():

    rows = db.executesql(USER_TABLE_QUERY);

    # # 0: User ID
    # # 1: User name
    # # 2: User mail
    # # 3: [Group ID 1, Group ID 2...]
    # # 4: [Group name 1, Group name 2...]

    users = []

    # First pass: append to users[] a list containing only the user's ID,
    # with placeholders for the other elements
    for row in rows:
        app_required = True
        print "Testing for user ID " + str(row[0])
        for i in range(len(users)):
            if users[i][0] == row[0]:
                app_required = False
        if app_required:
            users.append([row[0], '', '', [], []])

    # Second pass: update the user information

    for user in users:
        print "Going through user " + str(user[0])
        for i in range(len(rows)):
            print "I'm at row for user " + str(row[0])
            print row
            if rows[i][0] == user[0]:
                user[1] = rows[i][1] + ' ' + rows[i][2]
                user[2] = rows[i][3]
                user[3].append(rows[i][9])
                user[4].append(rows[i][10])

    print "Will pass this to view:"
    print users

    rows = db.executesql(TSO_TABLE_QUERY)
    tsos = []
    for row in rows:
        tsos.append([row[0], row[1], row[2]])

    return dict(users=users, tsos=tsos)

# Remove user identified by UID from the group identified with GID
@auth.requires_membership('Administrator')
def rm():
#    uid, gid
    uid = request.vars.u
    gid = request.vars.g
    query = "DELETE from auth_membership WHERE auth_membership.user_id == " + str(uid) + " AND auth_membership.group_id == " + str(gid) + ";"
    db.executesql(query)
    redirect(URL(r=request, f='index'))
    return dict()

@auth.requires_membership('Administrator')
def rmtso():
    uid = request.vars.t
    db(db.seetsoc_ohs_parties.id == uid).delete()
    redirect(URL(r=request, f='index'))
    return dict()

@auth.requires_membership('Administrator')
def makeadmin():
    uid = request.vars.u

    # Check if uid is already an administrator
    query = "SELECT id from auth_membership WHERE auth_membership.user_id == " + str(uid) + " AND auth_membership.group_id == " + str(ADMIN_ID) + ";"
    rows = db.executesql(query)
    if (len(rows) > 0):
        redirect(URL(r=request, f='index'))
        return

    # Add an administrator membership
    db.auth_membership.insert(user_id = uid, group_id = ADMIN_ID)
    redirect(URL(r=request, f='index'))
    return dict()

@auth.requires_membership('Administrator')
def makepart():
    uid = request.vars.u

    # Check if uid is already a participant
    query = "SELECT id from auth_membership WHERE auth_membership.user_id == " + str(uid) + " AND auth_membership.group_id == " + str(USER_ID) + ";"
    rows = db.executesql(query)
    if (len(rows) > 0):
        redirect(URL(r=request, f='index'))
        return

    db.auth_membership.insert(user_id = uid, group_id = USER_ID)
    redirect(URL(r=request, f='index'))
    return dict()

@auth.requires_membership('Administrator')
def changemail(uid):
    pass

@auth.requires_membership('Administrator')
def sendnotif(uid):
    pass


@auth.requires_membership('Administrator')
def defaultmbsh():
    form = SQLFORM(db.auth_membership)
    if form.process().accepted:
        response.flash = 'Successfully added new group membership'
    elif form.errors:
        response.flash = 'Invalid input data when editing membership'
    else:
        response.flash = 'Empty form!'
    return dict(form = form)

@auth.requires_membership('Administrator')
def adduser():
    form = SQLFORM(db.auth_user)
    if form.process().accepted:
        response.flash = 'Added new user'
    elif form.errors:
        response.flash = 'Invalid input data when adding new user'
    else:
        response.flash = 'Empty form!'
    return dict(form = form)

@auth.requires_membership('Administrator')
def addtso():
    form = SQLFORM(db.seetsoc_ohs_parties)
    if form.process().accepted:
        response.flash = 'Added new TSO'
    elif form.errors:
        response.flash = 'Invalid input data when registering new TSO'
    else:
        response.flash = 'Empty form!'
    return dict(form = form)
