# -*- coding: utf-8 -*-
from repr import rtoi, itor

#########################################################################
## This scaffolding model makes your app work on Google App Engine too
## File is released under public domain and you can use without limitations
#########################################################################

if not request.env.web2py_runtime_gae:
    ## if NOT running on Google App Engine use SQLite or other DB
    db = DAL('sqlite://storage.sqlite')
else:
    ## connect to Google BigTable (optional 'google:datastore://namespace')
    db = DAL('google:datastore')
    ## store sessions and tickets there
    session.connect(request, response, db = db)
    ## or store session in Memcache, Redis, etc.
    ## from gluon.contrib.memdb import MEMDB
    ## from google.appengine.api.memcache import Client
    ## session.connect(request, response, db = MEMDB(Client()))

## by default give a view/generic.extension to all actions from localhost
## none otherwise. a pattern can be 'controller/function.extension'
response.generic_patterns = ['*'] if request.is_local else []

#########################################################################
## Here is sample code if you need for
## - email capabilities
## - authentication (registration, login, logout, ... )
## - authorization (role based authorization)
## - services (xml, csv, json, xmlrpc, jsonrpc, amf, rss)
## - old style crud actions
## (more options discussed in gluon/tools.py)
#########################################################################

from gluon.tools import Auth, Crud, Service, PluginManager, prettydate
auth = Auth(db, hmac_key=Auth.get_or_create_key())
crud, service, plugins = Crud(db), Service(), PluginManager()

## create all tables needed by auth if not custom tables

## configure email
mail=auth.settings.mailer
mail.settings.server = 'logging' or 'smtp.gmail.com:587'
mail.settings.sender = 'you@gmail.com'
mail.settings.login = 'username:password'

## configure auth policy
auth.settings.registration_requires_verification = False
auth.settings.registration_requires_approval = False
auth.settings.reset_password_requires_verification = True

## if you need to use OpenID, Facebook, MySpace, Twitter, Linkedin, etc.
## register with janrain.com, write your domain:api_key in private/janrain.key
from gluon.contrib.login_methods.rpx_account import use_janrain
use_janrain(auth,filename='private/janrain.key')

#########################################################################
## Define your tables below (or better in another model file) for example
##
## >>> db.define_table('mytable',Field('myfield','string'))
##
## Fields can be 'string','text','password','integer','double','boolean'
##       'date','time','datetime','blob','upload', 'reference TABLENAME'
## There is an implicit 'id integer autoincrement' field
## Consult manual for more options, validators, etc.
##
## More API examples for controllers:
##
## >>> db.mytable.insert(myfield='value')
## >>> rows=db(db.mytable.myfield=='value').select(db.mytable.ALL)
## >>> for row in rows: print row.id, row.myfield
#########################################################################

mail.settings.server = settings.email_server
mail.settings.sender = settings.email_sender
mail.settings.login = settings.email_login



db.define_table('seetsoc_ohs_parties',
                Field('id', 'id'),
                Field('Name', type='string', required=True, notnull=True),
                Field('timezone', type='integer', required=True, notnull=True))

db.define_table('seetsoc_ohs_xmlhistory',
                Field('id', 'id'),
                Field('previd', type='integer', required=False, notnull=False),
                Field('offer_id', type='integer', required=True, notnull=False),
                Field('ack_time', type='datetime', required=True, notnull=True),
                Field('eic', type='string', required=True, notnull=True),
                Field('accepted', type='boolean', required=True, notnull=True),
                Field('filename', 'upload'),
                Field('valid', type='boolean', required=True, notnull=True),
                Field('entered_transaction', type='boolean', required=True, notnull=True, default = False))

db.define_table('seetsoc_ohs_offer',
                Field('id', 'id'),
                Field('eic', type='string', required=True, notnull=True),
                Field('delivery_date', type='date', required=True, notnull=True),
                Field('creation_date', type='datetime', required=True, notnull=True),
                Field('msg_version', type='integer', required=True, notnull=True),
                Field('off_type', type='integer', required=True, notnull=True))

db.define_table('seetsoc_ohs_bids',
                Field('id', 'id'),
                Field('offer_id', type='integer', required=True, notnull=True),
                Field('interval', type='integer', required=True, notnull=True),
                Field('price', type='decimal(6,2)', required=True, default=None, notnull=True),
                Field('qty', type='decimal(6,2)', required=True, default=None, notnull=True),
                Field('eng_type', type='integer', required=True, default=0, notnull=True),
                Field('bid_type', type='integer', required=True, notnull=True))

db.define_table('seetsoc_ohs_transactions',
                # Fields required for transaction settlement programming
                Field('id', 'id'),
                Field('party_id', type='integer', required=True, notnull=True),
                Field('bid_id', type='integer', required=True, notnull=True),
                Field('bid_type', type='integer', required=True, notnull=True),
                Field('eng_type', type='integer', required=True, notnull=True),
                Field('offer_id', type='integer', required=True, notnull=True),
                Field('delivery_date', type='date', required=True,
                      notnull=True),
                Field('interval', type='integer', required=True, notnull=True),
                Field('qty', type='integer', required=True, notnull=True),
                Field('mcp', type='integer', required=True, notnull=True),
                Field('orig_price', type='integer', required = True, notnull = True),
                # Fields required for transaction settlement adjustment
                Field('transactioned', type='boolean', required=True, notnull=True),
                Field('final_price', type='integer', required=True, notnull=True),
                Field('final_qty', type='integer'))
                # Fields required for imbalance prices

db.define_table('setsoc_ohs_settlement_notes',
                Field('id', 'id'),
                Field('date', type='date', required=True, notnull=True),
                Field('interval', type='integer', required=True),
                Field('metered_qty', type='integer', required=True),
                Field('vimb', type='decimal(6,2)', required=True),
                Field('TSO', type='integer', required=True))

db.define_table(
    auth.settings.table_user_name,
    Field('first_name', length=128, default=''),
    Field('last_name', length=128, default=''),
    Field('email', length=128, default='', unique=True),
    Field('TSO', type='integer'),
    Field('password', 'password', length=512, readable=False, label='Password'),
    Field('registration_key', length=512, writable=False, readable=False, default=''),
    Field('reset_password_key', length=512, writable=False, readable=False, default=''),
    Field('registration_id', length=512, writable=False, readable=False, default=''),
    format='%(first_name)s %(last_name)s')
member = db[auth.settings.table_user_name] # get the custom_auth_table
member.first_name.requires = \
    IS_NOT_EMPTY(error_message=auth.messages.is_empty)
member.last_name.requires = \
    IS_NOT_EMPTY(error_message=auth.messages.is_empty)
member.password.requires = [IS_STRONG(min=5, special=0, upper=0), CRYPT()]
member.email.requires = [
    IS_EMAIL(error_message=auth.messages.invalid_email),
    IS_NOT_IN_DB(db, 'auth_user.email')]

auth.define_tables()
