debug_flag = 1
import offer
if debug_flag == 1:
    import pdb

MODE_INCREASING_PRICE = 0
MODE_DECREASING_PRICE = 1

def get_stats(mo):
    stats = dict(mcp = 0,
                 selected_qty = 0,
                 avg_price = 0,
                 total_price = 0)

    stats["mcp"] = mo[2] / 100
    entries = 0
    for entry in mo[0]:
        entries = entries + 1
        stats["selected_qty"] += entry["qty"]
        stats["total_price"] += (entry["price"] * entry["qty"])

# Note: not in representation format
    stats["avg_price"] = (float(stats["total_price"]) / float(stats["selected_qty"])) / 100
    stats["total_price"] = stats["total_price"] / 100
    return stats

def debug(str):
    if debug_flag:
        print str

def debug_list(list):
    if debug_flag:
        for elem in list:
            print elem
            print "\n"

def qty(bid):
    return bid[3]

def price(bid):
    return bid[2]

def complete(bid):
    return bid[4]

def sort_bids(bids, mode):
    if mode == MODE_INCREASING_PRICE:
        return sorted(bids, key = lambda bid: price(bid))
    elif mode == MODE_DECREASING_PRICE:
        return sorted(bids, key = lambda bid: price(bid), reverse = True)

def get_mcp(buys, sales):
    debug("Finding mcp...\n")
    i = 0
    while (i != len(buys)) and (i < len(sales)):
        if price(buys[i]) < price(sales[i]):
            break
        i = i + 1
    if (i == 0):
        debug("MCP found at first element\n")
        return (float(price(buys[0])) + float(price(sales[0])))/2
    else:
        debug("MCP computed at " + str(i) + "th element\n")
        if (buys[0] > sales[0]):
            if (i < len(sales) - 2):
                return  (((float(price(buys[i])) + float(price(buys[i-1])))/2) + ((float(price(sales[i])) + float(price(sales[i + 1])))/2))/2
            else:
                return  (((float(price(buys[i])) + float(price(buys[i-1])))/2) + ((float(price(sales[i - 2])) + float(price(sales[i - 1])))/2))/2
        else:
            if (i < len(buys) - 2):
                return  (((float(price(buys[i])) + float(price(buys[i+1])))/2) + ((float(price(sales[i-1])) + float(price(sales[i-1])))/2))/2
            else:
                return  (((float(price(buys[i - 2])) + float(price(buys[i - 1])))/2) + ((float(price(sales[i])) + float(price(sales[i-1])))/2))/2

#         print("\n\n\\n\nMCP\n\n\n\n\n")
# #        print ( ( float(price(buys[i-1])) + float(price(sales[i-1]))) / 2 )
#         return ( ( float(price(buys[i+1])) + float(price(sales[i-1]))) / 2 )

def offer_diff(buys, sales):
    debug("Offer diff:\n")
    debug_list(buys)
    sb = 0
    ss = 0

    for i in range(len(buys)):
        debug(i)
        sb += qty(buys[i])

    for i in range(len(sales)):
        debug(i)
        ss += qty(sales[i])

    debug("Sales quantity = " + str(ss) + " buys quantity = " + str(sb))

    return sb - ss

def trim_to_selected(bids, q, min_qty):
    # Compute initial difference
    s = 0
    diff = 0

    for bid in bids:
        s += qty(bid)

    diff = s - q # We need to trim diff units

    if (diff > 0):
        debug("Some trimming is required to meet the maximum selected limit")
        while (len(bids) > 0):
            if qty(bids[len(bids) - 1]) > diff:
                if (qty(bids[len(bids) - 1]) - diff > min_qty):
                    bids[len(bids) - 1][5] = bids[len(bids) - 1][3]
                    bids[len(bids) - 1][4] = False
                    bids[len(bids) - 1][3] = bids[len(bids) - 1][3] - diff
                    return (bids, q)
                else:
                    debug("The last bid had to be discarded entirely, returning new trimmed quantity")
                    bids.pop()
                    for bid in bids:
                        s += qty(bid)
                    return (bids, s)
            else:
                diff = diff - qty(bids[len(bids) - 1])
                bids.pop()

    if len(bids) == 0:
        return None

def mo_upward_tertiary(buys, sales, limit = None, min_qty = 1):

    if len(buys) == 0 or len(sales) == 0:
        return None

    all_buys = sort_bids(buys, MODE_DECREASING_PRICE)
    all_sales = sort_bids(sales, MODE_INCREASING_PRICE)

    buy_transactions = []
    sell_transactions = []

    mcp = get_mcp(all_buys, all_sales)

    debug("Settled at MCP = " + str(mcp))

    # TODO: Check MCP here!

    # Filter bids based on MCP

    debug("Sorted buy offers: " + str(all_buys))
    debug("Sorted sale offers: " + str(all_sales))

    # End of step 1

    # Pass 1: remove all offers that are below MCP

    buys = filter(lambda bid: (float(price(bid)) < mcp), all_buys)
    sales = filter(lambda bid: (float(price(bid)) < mcp), all_sales)

    diff = offer_diff(buys, sales)

    debug("There is a " + str(diff) + " difference between buys and sales");

    # We reverse the list here so that they are both sorted in the
    # same order. This way, in the next step, we can go in the same
    # direction on both
    buys.reverse()

    while diff != 0:
        cut_from = buys
        restore_to = ""
        debug("Difference is non-zero, balancing required")

        if (diff > 0):
            debug("Cutting from buys:")
            debug_list(buys)
            cut_from = buys
            restore_to = "buys"
        else:
            cut_from = sales
            # If the difference is neggative, we take it in absolute value.
            # This way, when we update it, we don't care if we have to add or
            # remove the difference
            debug("Cutting from sales")
            debug_list(sales)
            diff = -diff
            restore_to = "sales"

        while (len(cut_from) > 0) and diff != 0 :
            if cut_from[len(cut_from) - 1][3] < diff:
                diff = diff - cut_from[len(cut_from) - 1][3]
                cut_from.pop()
            else:
                if (cut_from[len(cut_from) - 1][3] - diff) > min_qty:
                    cut_from[len(cut_from) - 1][3] = cut_from[len(cut_from) - 1][3] - diff
                    cut_from[len(cut_from) - 1][4] = False
                    cut_from[len(cut_from) - 1][5] = cut_from[len(cut_from) - 1][3] + diff
                    diff = 0
                    break
                else:
                    # Pop down to minimal quantity and rerun the algorithm for the other
                    # sequence
                    cut_from[len(cut_from) - 1][5] = cut_from[len(cut_from) - 1][3]
                    cut_from[len(cut_from) - 1][3] = min_qty
                    cut_from[len(cut_from) - 1][4] = False
                    diff = diff - cut_from[len(cut_from) - 1][5] + min_qty
                    if (restore_to == "buys"):
                        diff = -diff
                    debug("Minimum quantity reached, difference is " + str(diff))
                    continue
                    break

        if (restore_to == "buys"):
            buys = cut_from
        else:
            sales = cut_from

    # Trim to max quantity if required
            # def trim_to_selected(bids, qty, min_qty):
    if limit != None:
        ts = -1
        tb = 1
        while (ts != tb):
            trim_info = trim_to_selected(buys, limit, min_qty)
            buys = trim_info[0]
            tb = trim_info[1]

            trim_info = trim_to_selected(sales, limit, min_qty)
            sales = trim_info[0]
            ts = trim_info[1]


    buy_transactions = []
    sale_transactions = []

    for bid in buys:
        buy_transactions.append(dict(offer_id = bid[0],
                                     bid_id = bid[1],
                                     price = bid[2],
                                     qty = bid[3],
                                     complete = bid[4],
                                     orig_qty = bid[5],
                                     tso_id = bid[6],
                                     tso_name = bid[7]))
    for bid in reversed(sales):
        sale_transactions.append(dict(offer_id = bid[0],
                                      bid_id = bid[1],
                                      price = bid[2],
                                      qty = bid[3],
                                      complete = bid[4],
                                      orig_qty = bid[5],
                                      tso_id = bid[6],
                                      tso_name = bid[7]))
    debug("Final selected buy offers:\n")
    debug_list(buys)
    debug("Final selected sale offers:\n ")
    debug_list(sales)

    debug("Final buy transactions: " + str(buy_transactions))
    debug("Final sale transactions: " + str(sale_transactions))

    return (buy_transactions, sale_transactions, mcp, all_buys, all_sales)

def mo_downward_tertiary(buys, sales, limit = None, min_qty = 1):
    return mo_upward_tertiary(sales, buys, limit, min_qty)
